diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/default-emlsr-manager.h ns-3.43/src/wifi/model/eht/default-emlsr-manager.h
--- ns-3.42/src/wifi/model/eht/default-emlsr-manager.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/eht/default-emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -47,20 +36,55 @@
   protected:
     uint8_t GetLinkToSendEmlOmn() override;
     std::optional<uint8_t> ResendNotification(Ptr<const WifiMpdu> mpdu) override;
+    std::pair<bool, Time> DoGetDelayUntilAccessRequest(uint8_t linkId) override;
+    void SwitchMainPhyIfTxopGainedByAuxPhy(uint8_t linkId, AcIndex aci) override;
+    std::pair<bool, Time> GetDelayUnlessMainPhyTakesOverUlTxop(uint8_t linkId) override;
+
+    /**
+     * This function is intended to be called when an aux PHY is about to transmit an RTS on
+     * the given link to calculate the time remaining to the end of the CTS reception.
+     *
+     * \param linkId the ID of the given link
+     * \return the time remaining to the end of the CTS reception
+     */
+    Time GetTimeToCtsEnd(uint8_t linkId) const;
+
+    /**
+     * This method can only be called when aux PHYs do not switch link. Switch the main PHY back
+     * to the primary link and reconnect the aux PHY that was operating on the link left by the
+     * main PHY.
+     *
+     * \param linkId the ID of the link that the main PHY is leaving
+     */
+    void SwitchMainPhyBackToPrimaryLink(uint8_t linkId);
+
+    /// Store information about a main PHY switch.
+    struct MainPhySwitchInfo
+    {
+        Time end;     //!< end of channel switching
+        uint8_t from; //!< ID of the link which the main PHY is/has been leaving
+    };
+
+    bool m_switchAuxPhy;  /**< whether Aux PHY should switch channel to operate on the link on which
+                               the Main PHY was operating before moving to the link of the Aux PHY */
+    bool m_auxPhyToSleep; //!< whether Aux PHY should be put into sleep mode while the Main PHY
+                          //!< is operating on the same link as the Aux PHY
+    EventId m_auxPhyToSleepEvent;     //!< the event scheduled to put an Aux PHY into sleep mode
+    Ptr<WifiPhy> m_auxPhyToReconnect; //!< Aux PHY the ChannelAccessManager of the link on which
+                                      //!< the main PHY is operating has to connect a listener to
+                                      //!< when the main PHY is back operating on its previous link
+    EventId m_auxPhySwitchEvent;      //!< event scheduled for an aux PHY to switch link
+    MainPhySwitchInfo m_mainPhySwitchInfo; //!< main PHY switch info
 
   private:
     void DoNotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId) override;
     void NotifyEmlsrModeChanged() override;
-    void NotifyMainPhySwitch(uint8_t currLinkId, uint8_t nextLinkId) override;
+    void NotifyMainPhySwitch(std::optional<uint8_t> currLinkId,
+                             uint8_t nextLinkId,
+                             Time duration) override;
     void DoNotifyIcfReceived(uint8_t linkId) override;
     void DoNotifyUlTxopStart(uint8_t linkId) override;
     void DoNotifyTxopEnd(uint8_t linkId) override;
-
-    bool m_switchAuxPhy; /**< whether Aux PHY should switch channel to operate on the link on which
-                              the Main PHY was operating before moving to the link of the Aux PHY */
-    Ptr<WifiPhy> m_auxPhyToReconnect; //!< Aux PHY the ChannelAccessManager of the link on which
-                                      //!< the main PHY is operating has to connect a listener to
-                                      //!< when the main PHY is back operating on its previous link
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/eht-capabilities.cc ns-3.43/src/wifi/model/eht/eht-capabilities.cc
--- ns-3.42/src/wifi/model/eht/eht-capabilities.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/eht/eht-capabilities.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 DERONNE SOFTWARE ENGINEERING
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/eht-capabilities.h ns-3.43/src/wifi/model/eht/eht-capabilities.h
--- ns-3.42/src/wifi/model/eht/eht-capabilities.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/eht-capabilities.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 DERONNE SOFTWARE ENGINEERING
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -255,7 +244,8 @@
      * Constructor
      *
      * \param is2_4Ghz indicating whether PHY is operating in 2.4 GHz based on previously serialized
-     * IEs \param heCapabilities the optional HE capabilities contained in the same management frame
+     * IEs
+     * \param heCapabilities the optional HE capabilities contained in the same management frame
      */
     EhtCapabilities(bool is2_4Ghz, const std::optional<HeCapabilities>& heCapabilities);
     // Implementations of pure virtual methods, or overridden from base class.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/eht-configuration.cc ns-3.43/src/wifi/model/eht/eht-configuration.cc
--- ns-3.42/src/wifi/model/eht/eht-configuration.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/eht-configuration.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 DERONNE SOFTWARE ENGINEERING
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Sébastien Deronne <sebastien.deronne@gmail.com>
  *          Stefano Avallone <stavallo@unina.it>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/eht-configuration.h ns-3.43/src/wifi/model/eht/eht-configuration.h
--- ns-3.42/src/wifi/model/eht/eht-configuration.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/eht-configuration.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 DERONNE SOFTWARE ENGINEERING
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Sébastien Deronne <sebastien.deronne@gmail.com>
  *          Stefano Avallone <stavallo@unina.it>
@@ -51,16 +40,22 @@
     ANY_LINK_SET = 3
 };
 
+/**
+ * Deprecated link mapping support enums.
+ *
+ * Use `WifiTidToLinkMappingNegSupport` class enum values instead.
+ * @{
+ */
 NS_DEPRECATED_3_42("Use WifiTidToLinkMappingNegSupport::NOT_SUPPORTED instead")
-static constexpr auto WIFI_TID_TO_LINK_MAPPING_NOT_SUPPORTED = WifiTidToLinkMappingNegSupport::
-    NOT_SUPPORTED; //!< \deprecated See WifiTidToLinkMappingNegSupport::NOT_SUPPORTED
+static constexpr auto WIFI_TID_TO_LINK_MAPPING_NOT_SUPPORTED =
+    WifiTidToLinkMappingNegSupport::NOT_SUPPORTED;
 NS_DEPRECATED_3_42("Use WifiTidToLinkMappingNegSupport::SAME_LINK_SET instead")
-static constexpr auto WIFI_TID_TO_LINK_MAPPING_SAME_LINK_SET = WifiTidToLinkMappingNegSupport::
-    SAME_LINK_SET; //!< \deprecated See WifiTidToLinkMappingNegSupport::SAME_LINK_SET
+static constexpr auto WIFI_TID_TO_LINK_MAPPING_SAME_LINK_SET =
+    WifiTidToLinkMappingNegSupport::SAME_LINK_SET;
 NS_DEPRECATED_3_42("Use WifiTidToLinkMappingNegSupport::ANY_LINK_SET instead")
 static constexpr auto WIFI_TID_TO_LINK_MAPPING_ANY_LINK_SET =
-    WifiTidToLinkMappingNegSupport::ANY_LINK_SET; //!< \deprecated See
-                                                  //!< WifiTidToLinkMappingNegSupport::ANY_LINK_SET
+    WifiTidToLinkMappingNegSupport::ANY_LINK_SET;
+/**@}*/
 
 /**
  * \brief Stream insertion operator.
